#ifndef COMMON_H_QPRCB1BH
#define COMMON_H_QPRCB1BH

#include <stdlib.h>
#include <time.h>

struct dynamic_array {
    size_t entry_size;
    size_t grow_size;
    size_t allocated;
    size_t entries;
    void *a;
};

#define DYNARRAY_ITEM(da, index) ( (char *)(da).a + ( (da).entry_size * index ) )

int dynarray_init(struct dynamic_array *da, size_t entry_size, size_t grow_size);
struct dynamic_array *dynarray_new(size_t entry_size, size_t grow_size);
void *dynarray_add(struct dynamic_array *da, void *item);
void dynarray_empty(struct dynamic_array *da, void (*free_element)(void *));

int str_to_word(char *s);

char *strqtok_r(char *str, const char *sep, int esc, const char *quote, char **lastq, char **lasts);

int gettimespecofday(struct timespec *ts);
int timespec_add(struct timespec *result, const struct timespec *x);
int timespec_subtract(struct timespec *result, struct timespec *x, struct timespec *y);

#endif /* COMMON_H_QPRCB1BH */
